
#include <Ethernet.h>
#include <EthernetUdp.h>
#include <SPI.h>    

#include <OSCBundle.h>
#include <OSCBoards.h>

/*
* testOSCRouting
* OSC controlled blink
*/

//UDP communication
EthernetUDP Udp;
byte mac[] = {  
  0xDF, 0x3B, 0x9C, 0xCF, 0x93, 0xA7 }; // you can find this written on the board of some Arduino Ethernets or shields

//the Arduino's IP
IPAddress ip(192, 168, 0, 90);

//port numbers
const unsigned int inPort = 8888;


void processBlinkCommand(OSCMessage &msg, int addrOffset) {
  Serial.println("processing blink command");
  if (msg.isFloat(0)) {   //note that Pd doesn't have integers
    float f = msg.getFloat(0);
    Serial.print("got float ");
    Serial.println(f); 
//    for (int i = floor(f); i--; ) {  //I think pin 13 is used by SPI for the ethernet shield
//      digitalWrite(LED_BUILTIN, digitalRead(LED_BUILTIN) == HIGH? LOW : HIGH);
//      delay(250);
//    }
  }
}


void processLEDCommand(OSCMessage &msg, int addrOffset) {
  Serial.println("processing led command");
  if (msg.isFloat(0)) {
    float f = msg.getFloat(0);
//    digitalWrite(LED_BUILTIN, f == 0? LOW : HIGH);  //I think pin 13 is used by SPI for the ethernet shield
    Serial.print("got float ");
    Serial.println(f);
  }
}


void processTest(OSCMessage &msg, int addrOffset) {
  Serial.println("processing test");
  if (msg.route("/blink", processBlinkCommand, addrOffset)) return;
  if (msg.route("/led", processLEDCommand, addrOffset)) return;
}


void setup() {
  //setup ethernet part
  Ethernet.begin(mac,ip);
  Udp.begin(inPort);

  Serial.begin(9600);
  Serial.println("hello");
}


//reads and dispatches the incoming message
void loop(){ 
  OSCMessage messageIN;
  int size;
 
  if( (size = Udp.parsePacket())>0) {
    while(size--)
      messageIN.fill(Udp.read());

    if(!messageIN.hasError()) {
      Serial.println("got udp packet");
      messageIN.route("/test", processTest);
    }
  }
}
